-- Test remove_services_carousel_slide
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(12);

set search_path to camper, public;

select has_function('camper', 'remove_services_carousel_slide', array['integer']);
select function_lang_is('camper', 'remove_services_carousel_slide', array['integer'], 'sql');
select function_returns('camper', 'remove_services_carousel_slide', array['integer'], 'void');
select isnt_definer('camper', 'remove_services_carousel_slide', array['integer']);
select volatility_is('camper', 'remove_services_carousel_slide', array['integer'], 'volatile');
select function_privs_are('camper', 'remove_services_carousel_slide', array['integer'], 'guest', array[]::text[]);
select function_privs_are('camper', 'remove_services_carousel_slide', array['integer'], 'employee', array[]::text[]);
select function_privs_are('camper', 'remove_services_carousel_slide', array['integer'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'remove_services_carousel_slide', array['integer'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate services_carousel_i18n cascade;
truncate services_carousel cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;

insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('text/plain', 'hello, world!')
     , ('image/svg+xml', '<svg xmlns="http://www.w3.org/2000/svg" width="1" height="1"/>')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (5, 1, 'text.txt', sha256('hello, world!'))
     , (6, 1, 'image.svg', sha256('<svg xmlns="http://www.w3.org/2000/svg" width="1" height="1"/>'))
     , (7, 1, 'cover4.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
;

insert into services_carousel (media_id, caption)
values (5, 'Source caption')
     , (6, 'Another caption')
     , (7, 'N/A')
;

insert into services_carousel_i18n (media_id, lang_tag, caption)
values (5, 'en', 'Target caption')
     , (5, 'es', 'Target caption (spanish)')
     , (6, 'en', 'Target caption')
     , (6, 'es', 'Target caption (spanish)')
     , (7, 'en', 'Target caption')
     , (7, 'es', 'Target caption (spanish)')
;

select lives_ok(
	$$ select remove_services_carousel_slide(6) $$,
	'Should be able to delete a slide'
);

select bag_eq(
	$$ select media_id, caption from services_carousel $$,
	$$ values (5, 'Source caption')
	        , (7, 'N/A')
	$$,
	'Should have removed the slide'
);

select bag_eq(
	$$ select media_id, lang_tag, caption from services_carousel_i18n $$,
	$$ values (5, 'en', 'Target caption')
	        , (5, 'es', 'Target caption (spanish)')
	        , (7, 'en', 'Target caption')
	        , (7, 'es', 'Target caption (spanish)')
	$$,
	'Should have removed the slide’s translations'
);


select *
from finish();

rollback;
